require_relative '../lib/zephyr_client'
#require 'zephyr_client'
require 'json'

opts = ZephyrClient::Utils::parseCommandLine();
#puts __FILE__ + (__LINE__).to_s + " OPTS => #{opts}" if opts[:verbose]

z = ZephyrClient::Client.new(opts[:config])
z.setUser( {:username => opts[:user], :password => 'Eruption1978!' })

#puts opts


rc = z.getProjectPerRelease(opts[:project], opts[:release], opts[:cycle], opts[:debug])

if opts[:verbose]
  puts '-' * 72
  puts "== PROJECT PER RELEASE =="
  puts __FILE__ + (__LINE__).to_s + " => #{rc}"
  puts ' -- Executions --'
end

executions = z.getExecutions(rc)
puts "Total Records: #{executions['recordsCount']}"


if opts.has_key?(:jira)
  filterKey = 'issueKey'
  i=0
  filter = { filterKey => opts[:jira]}   # CORUI-3212


  executions['executions'].each do |e|
    if filter[filterKey] && e.has_key?(filterKey) && (e[filterKey] == filter[filterKey])
      puts "#{i}. #{e}" if opts[:verbose]


      if opts.has_key?(:status)

        operationRc = z.updateTestStatus(e['id'], opts[:status])   # pass, fail, wip, blocked, unexecuted

        opStatus = 'Unsuccessfully'
        if operationRc.is_a?(Net::HTTPOK)
          opStatus = 'Successfully'
        end
        puts "#{opStatus} updated status to '#{opts[:status]}' : #{e['issueKey']} : #{e['summary']}"
      end


      i+=1
    end

  end

else
  puts '*' * 72
  pp executions['executions']
end
