require 'json'
require 'net/https'
require 'cgi/cookie'
require 'pp'
require 'uri'


class HTTPClient

  attr_accessor :debug
  attr_accessor :user
  attr_accessor :request

  def initialize(user)
    @debug = false
    @user = user
  end

  def self.createRequest(user, http_method='get', path=nil, body=nil, headers={})
    request = Net::HTTP.const_get(http_method.to_s.capitalize).new(path, headers)
    request.body = body unless body.nil?
    request.basic_auth(user[:username], user[:password])
    request
  end


end